<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        $sql = <<<'SQL'
            CREATE TABLE pallet_validations (
                id                          BIGINT GENERATED always AS IDENTITY PRIMARY KEY,

                plant_id                    BIGINT NOT NULL,

                pallet_number               TEXT NULL,
                serial_number               TEXT NOT NULL,
                pallet_status               TEXT NULL,
                locator_number              TEXT NULL,
                locator_quantity            INT NOT NULL DEFAULT (0),

                created_at                  TIMESTAMP NOT NULL DEFAULT NOW(),
                updated_at                  TIMESTAMP NOT NULL DEFAULT NOW(),
                scanned_at                  TIMESTAMP NOT NULL DEFAULT NOW(),
                deleted_at                  TIMESTAMP,

                created_by                  TEXT NOT NULL,
                scanned_by                  TEXT NOT NULL,
                updated_by                  TEXT NULL,

                UNIQUE (plant_id, serial_number),
                FOREIGN KEY (plant_id)      REFERENCES  plants (id)
            );
        SQL;

        DB::statement($sql);
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('pallet_validations');
    }
};
